/* ucode_header.v - Labels and global information useful to modules interfacing with the microcode

   This file is part of the 9086 project.

   Copyright (c) 2023 Efthymios Kritikos

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

`define UCODE_SIZE 12
`define UCODE_DATA_BITS 38
`define UCODE_ADDR_BITS $clog2(`UCODE_SIZE)

/* DEFINE ADDRESSES IN THE MICROCODE */
`define UCODE_NO_INSTRUCTION	4'b0000
`define UCODE_CALL_ENTRY	4'b0001
`define UCODE_RET_ENTRY		4'b0100
`define UCODE_STOS_ENTRY	4'b0110
`define UCODE_PUSH_ENTRY        4'b1000
`define UCODE_POP_ENTRY		4'b1010
